<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- jsextensions-general.qdoc -->
  <title>General Services | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >General Services</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#available-operations">Available Operations</a></li>
<li class="level2"><a href="#require">require</a></li>
<li class="level1"><a href="#extensions-to-javascript-built-in-objects">Extensions to JavaScript Built-in Objects</a></li>
<li class="level2"><a href="#array-contains">Array.contains</a></li>
<li class="level2"><a href="#array-containsall">Array.containsAll</a></li>
<li class="level2"><a href="#array-containsany">Array.containsAny</a></li>
<li class="level2"><a href="#array-uniqueconcat">Array.uniqueConcat</a></li>
<li class="level2"><a href="#string-contains">String.contains</a></li>
<li class="level2"><a href="#startswith">startsWith</a></li>
<li class="level2"><a href="#endswith">endsWith</a></li>
<li class="level1"><a href="#console-api">Console API</a></li>
<li class="level2"><a href="#console-debug">console.debug</a></li>
<li class="level2"><a href="#console-error">console.error</a></li>
<li class="level2"><a href="#console-info">console.info</a></li>
<li class="level2"><a href="#console-log">console.log</a></li>
<li class="level2"><a href="#console-warn">console.warn</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">General Services</h1>
<span class="subtitle"></span>
<!-- $$$jsextensions-general.html-description -->
<div class="descr"> <a name="details"></a>
<p>These are operations that do not fit into any of the other categories. They are automatically available in any Qbs project file or JavaScript file.</p>
<a name="available-operations"></a>
<h2 id="available-operations">Available Operations</h2>
<a name="require"></a>
<h3 id="require">require</h3>
<pre class="cpp">

  require(identifier: string): any

</pre>
<p>Loads an extension and returns an object representing the extension. If <i>identifier</i> is a relative or absolute file path, this function will load a JavaScript file and return an object containing the evaluated context of that file. Otherwise, loads a Qbs extension named <i>identifier</i> and returns an object that contains the extension's context. This function is only available in JavaScript files and is designed to behave similarly to the CommonJS/RequireJS/Node.js module resolution systems.</p>
<pre class="cpp">

  var MyFunctions <span class="operator">=</span> require(<span class="string">&quot;./myfunctions.js&quot;</span>);
  MyFunctions<span class="operator">.</span>doSomething();
  var FileInfo <span class="operator">=</span> require(<span class="string">&quot;qbs.FileInfo&quot;</span>);
  var fileName <span class="operator">=</span> FileInfo<span class="operator">.</span>fileName(filePath);

</pre>
<a name="extensions-to-javascript-built-in-objects"></a>
<h2 id="extensions-to-javascript-built-in-objects">Extensions to JavaScript Built-in Objects</h2>
<a name="array-contains"></a>
<h3 id="array-contains">Array.contains</h3>
<pre class="cpp">

  Array<span class="operator">.</span>contains(e: any): boolean

</pre>
<p>Returns <code>true</code> if the array contains the element <code>e</code>. Returns <code>false</code> otherwise.</p>
<a name="array-containsall"></a>
<h3 id="array-containsall">Array.containsAll</h3>
<pre class="cpp">

  Array<span class="operator">.</span>containsAll(other: any<span class="operator">[</span><span class="operator">]</span>): boolean

</pre>
<p>Returns <code>true</code> if the array contains every element in the <code>other</code> array. Returns <code>false</code> otherwise.</p>
<a name="array-containsany"></a>
<h3 id="array-containsany">Array.containsAny</h3>
<pre class="cpp">

  Array<span class="operator">.</span>containsAny(other: any<span class="operator">[</span><span class="operator">]</span>): boolean

</pre>
<p>Returns <code>true</code> if the array contains some element(s) in the <code>other</code> array. Returns <code>false</code> otherwise.</p>
<a name="array-uniqueconcat"></a>
<h3 id="array-uniqueconcat">Array.uniqueConcat</h3>
<pre class="cpp">

  Array<span class="operator">.</span>uniqueConcat(other: any<span class="operator">[</span><span class="operator">]</span>): any<span class="operator">[</span><span class="operator">]</span>

</pre>
<p>Returns a copy of this array joined with the array <code>other</code>. Duplicates that would originate from the concatenation are removed. The order of elements is preserved.</p>
<a name="string-contains"></a>
<h3 id="string-contains">String.contains</h3>
<pre class="cpp">

  String<span class="operator">.</span>contains(s: string): boolean

</pre>
<p>Returns <code>true</code> if the string contains the substring <code>s</code>. Returns <code>false</code> otherwise.</p>
<a name="startswith"></a>
<h3 id="startswith">startsWith</h3>
<pre class="cpp">

  String<span class="operator">.</span>startsWith(s: string): boolean

</pre>
<p>Returns <code>true</code> if the string starts with the substring <code>s</code>. Returns <code>false</code> otherwise.</p>
<a name="endswith"></a>
<h3 id="endswith">endsWith</h3>
<pre class="cpp">

  String<span class="operator">.</span>endsWith(s: string): boolean

</pre>
<p>Returns <code>true</code> if the string ends with the substring <code>s</code>. Returns <code>false</code> otherwise.</p>
<a name="console-api"></a>
<h2 id="console-api">Console API</h2>
<p>Qbs provides a subset of the non-standard Console API available in most ECMAScript runtimes.</p>
<p>The output of each of these functions will only be displayed if the logging level is at least the level which the function outputs at. Logging levels from lowest to highest are: 'error', 'warning', 'info', 'debug', and 'trace'. The default is 'info'.</p>
<p><b>Warning:</b> The contents of this section are subject to change in order to align with future <a href="https://www.w3.org/2011/08/browser-testing-charter.html">standardization</a> <a href="https://github.com/DeveloperToolsWG/console-object/blob/master/api.md">processes</a>.</p>
<a name="console-debug"></a>
<h3 id="console-debug">console.debug</h3>
<pre class="cpp">

  console<span class="operator">.</span>debug(s: string): <span class="type">void</span>

</pre>
<p>This method is an alias for <code>console.log()</code>.</p>
<a name="console-error"></a>
<h3 id="console-error">console.error</h3>
<pre class="cpp">

  console<span class="operator">.</span>error(s: string): <span class="type">void</span>

</pre>
<p>Logs an <code>error</code> level message. Outputs to stderr when the logger output is a terminal. The string will be prefixed with <code>&quot;ERROR: &quot;</code> and colored red when the logger output is a color-capable terminal.</p>
<a name="console-info"></a>
<h3 id="console-info">console.info</h3>
<pre class="cpp">

  console<span class="operator">.</span>info(s: string): <span class="type">void</span>

</pre>
<p>Logs an <code>info</code> level message. Outputs to stdout when the logger output is a terminal.</p>
<a name="console-log"></a>
<h3 id="console-log">console.log</h3>
<pre class="cpp">

  console<span class="operator">.</span>log(s: string): <span class="type">void</span>

</pre>
<p>Logs a <code>debug</code> level message. Outputs to stderr when the logger output is a terminal.</p>
<a name="console-warn"></a>
<h3 id="console-warn">console.warn</h3>
<pre class="cpp">

  console<span class="operator">.</span>warn(s: string): <span class="type">void</span>

</pre>
<p>Logs a <code>warning</code> level message. Outputs to stderr when the logger output is a terminal. The string will be prefixed with <code>&quot;WARNING: &quot;</code> and colored yellow when the logger output is a color-capable terminal.</p>
</div>
<!-- @@@jsextensions-general.html -->
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
